    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2006, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------------------
    028     * StandardXYSeriesLabelGenerator.java
    029     * -----------------------------------
    030     * (C) Copyright 2004-2006, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: StandardXYSeriesLabelGenerator.java,v 1.5.2.2 2006/11/24 16:36:33 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 16-Nov-2004 : Version 1 (DG);
    040     * ------------- JFREECHART 1.0.x ---------------------------------------------
    041     * 24-Nov-2006 : Fixed equals() method and updated API docs (DG);
    042     *
    043     */
    044
    045    package org.jfree.chart.labels;
    046
    047    import java.io.Serializable;
    048    import java.text.MessageFormat;
    049
    050    import org.jfree.data.xy.XYDataset;
    051    import org.jfree.util.PublicCloneable;
    052
    053    /**
    054     * A standard series label generator for plots that use data from
    055     * an {@link org.jfree.data.xy.XYDataset}.
    056     * <br><br>
    057     * This class implements <code>PublicCloneable</code> by mistake but we retain
    058     * this for the sake of backward compatibility.
    059     */
    060    public class StandardXYSeriesLabelGenerator implements XYSeriesLabelGenerator,
    061                                                           Cloneable,
    062                                                           PublicCloneable,
    063                                                           Serializable {
    064
    065        /** For serialization. */
    066        private static final long serialVersionUID = 1916017081848400024L;
    067
    068        /** The default item label format. */
    069        public static final String DEFAULT_LABEL_FORMAT = "{0}";
    070
    071        /** The format pattern. */
    072        private String formatPattern;
    073
    074        /**
    075         * Creates a default series label generator (uses
    076         * {@link #DEFAULT_LABEL_FORMAT}).
    077         */
    078        public StandardXYSeriesLabelGenerator() {
    079            this(DEFAULT_LABEL_FORMAT);
    080        }
    081
    082        /**
    083         * Creates a new series label generator.
    084         *
    085         * @param format  the format pattern (<code>null</code> not permitted).
    086         */
    087        public StandardXYSeriesLabelGenerator(String format) {
    088            if (format == null) {
    089                throw new IllegalArgumentException("Null 'format' argument.");
    090            }
    091            this.formatPattern = format;
    092        }
    093
    094        /**
    095         * Generates a label for the specified series.  This label will be
    096         * used for the chart legend.
    097         *
    098         * @param dataset  the dataset (<code>null</code> not permitted).
    099         * @param series  the series.
    100         *
    101         * @return A series label.
    102         */
    103        public String generateLabel(XYDataset dataset, int series) {
    104            if (dataset == null) {
    105                throw new IllegalArgumentException("Null 'dataset' argument.");
    106            }
    107            String label = MessageFormat.format(
    108                this.formatPattern, createItemArray(dataset, series)
    109            );
    110            return label;
    111        }
    112
    113        /**
    114         * Creates the array of items that can be passed to the
    115         * {@link MessageFormat} class for creating labels.
    116         *
    117         * @param dataset  the dataset (<code>null</code> not permitted).
    118         * @param series  the series (zero-based index).
    119         *
    120         * @return The items (never <code>null</code>).
    121         */
    122        protected Object[] createItemArray(XYDataset dataset, int series) {
    123            Object[] result = new Object[1];
    124            result[0] = dataset.getSeriesKey(series).toString();
    125            return result;
    126        }
    127
    128        /**
    129         * Returns an independent copy of the generator.  This is unnecessary,
    130         * because instances are immutable anyway, but we retain this
    131         * behaviour for backwards compatibility.
    132         *
    133         * @return A clone.
    134         *
    135         * @throws CloneNotSupportedException if cloning is not supported.
    136         */
    137        public Object clone() throws CloneNotSupportedException {
    138            return super.clone();
    139        }
    140
    141        /**
    142         * Tests this object for equality with an arbitrary object.
    143         *
    144         * @param obj  the other object (<code>null</code> permitted).
    145         *
    146         * @return A boolean.
    147         */
    148        public boolean equals(Object obj) {
    149            if (obj == this) {
    150                return true;
    151            }
    152            if (!(obj instanceof StandardXYSeriesLabelGenerator)) {
    153                return false;
    154            }
    155            StandardXYSeriesLabelGenerator that
    156                    = (StandardXYSeriesLabelGenerator) obj;
    157            if (!this.formatPattern.equals(that.formatPattern)) {
    158                return false;
    159            }
    160            return true;
    161        }
    162
    163    }